Attribute VB_Name = "Centipede"
Public CharImage(0 To 4096) As Byte
Public WarpCharSet(0 To 16384) As Byte

Dim SPRITE_OFFSET As Integer
Dim SPRITE_XPOS As Integer
Dim SPRITE_YPOS As Integer

Dim viewpic As Byte

Public KEY_ESC As Byte
Public KEY_3 As Byte
Public KEY_2 As Byte
Public KEY_1 As Byte
Public KEY_CTRL As Byte
Public KEY_UP As Byte
Public KEY_LEFT As Byte
Public KEY_DOWN As Byte
Public KEY_RIGHT As Byte

Public keyboard(255) As Byte
Public vScreen(66048) As Long

Public Function Main()
  Dim test As Long
  Dim vx As Integer, vy As Integer
  
  'Clear all keycodes
  KEY_ESC = 0
  KEY_3 = 0
  KEY_2 = 0
  KEY_1 = 0
  KEY_CTRL = 0
  KEY_UP = 0
  KEY_LEFT = 0
  KEY_DOWN = 0
  KEY_RIGHT = 0
  
  'Set first virtual screen
  viewpic = 1
  
  'Define Parameters in Centipede
  SPRITE_OFFSET = &H7C0
  SPRITE_XPOS = &H7D0
  SPRITE_YPOS = &H7E0
  AddressMask = &H3FFF
  
  Arcade.ArcadeScreen.Cls
  Erase vScreen
  
  'Clear rom area
  ReDim gameImage(&HFFFF&) As Byte
  For test = 0 To 16384
    gameImage(test) = 0
  Next test
  
  'Load the roms
  loadchar App.Path & "\centiped\centiped.211", &H0&
  loadchar App.Path & "\centiped\centiped.212", &H800&
  loadrom App.Path & "\centiped\centiped.307", &H2000&
  loadrom App.Path & "\centiped\centiped.308", &H2800&
  loadrom App.Path & "\centiped\centiped.309", &H3000&
  loadrom App.Path & "\centiped\centiped.310", &H3800&
  
  'Turn the service mode off
  gameImage(&HC00) = &H60
  
  'Implement Hack protection
  gameImage(&H38A8) = &HEA
  gameImage(&H38A9) = &HEA
  gameImage(&H38AE) = &HEA
  gameImage(&H38AF) = &HEA
    
  'Dipswitch Settings...
  Write6502 &H800, &H0
  Write6502 &H801, &H1
      
  WarpChars
  
'  VirBMP = CreateCompatibleBitmap(arcade.ArcadeScreen.hdc, 255, 255)
'  lbBits = GlobalAlloc(0, 256& * 500&)
'  GetBitmapBits VirBMP, 255& * 255&, lbBits
  
  M6502_Init 9000
  M6502_Reset
  
  
End Function

Public Function loadrom(filename As String, startadress As Integer)
  Dim i As Long
  
  Open filename For Binary Access Read As #1
  
  If FileLen(filename) <= 0 Then
    MsgBox "Place ROMs in the same directory as the executable, named Centiped.307-310 and Centiped.211-212"
    End
  End If
  For i = startadress To startadress + FileLen(filename)
    Get #1, , gameImage(i)
    Next i
  Close #1

End Function

Public Function loadchar(filename As String, startadress As Integer)
  Dim i As Integer
  
  Open filename For Binary Access Read As #1
  For i = startadress To startadress + FileLen(filename)
    Get #1, , CharImage(i)
    Next i
  Close #1

End Function

Public Function WarpChars()
  Dim X As Integer, cx As Integer, cy As Integer, bit As Integer
  Dim result As Byte
  Dim count As Integer
  count = 0
  For cy = 0 To 7
    For cx = 0 To 31
      For bit = 7 To 0 Step -1
        For X = 0 To 7
          result = 0
          If GetBit(bit + (X * 8) + (cx * 64) + (cy * 2048)) Then result = 1
          If GetBit(bit + (X * 8) + (cx * 64) + (cy * 2048) + 16384) Then result = result Xor 2
          WarpCharSet(count) = result
          count = count + 1
        Next X
      Next bit
    Next cx
  Next cy
End Function

Public Function GetBit(startbit As Integer) As Integer
  Dim nbyte As Integer
  Dim nbit As Integer
  Dim mask As Integer
  
  nbyte = startbit \ 8
  nbit = startbit Mod 8
  mask = &H80
  mask = mask \ 2 ^ nbit
  
  If (CharImage(nbyte) And mask) = mask Then
    GetBit = 1
  Else
    GetBit = 0
  End If
End Function

Public Function RedrawScreen()
  Dim X As Integer, Y As Integer, count As Integer
  Dim xpos As Integer
  Dim ypos As Integer
  Dim Offset As Integer
  Dim tid As Double
  Dim sluttid As Double
  Dim cx As Integer
  Dim cy As Integer
  Dim start As Integer
  Dim hdc As Integer
  Dim x1 As Integer
  Dim y1 As Integer
  Dim col As Long
  tid = Timer
  Dim virx As Integer, viry As Integer
  
  count = 0
  'Draw chars
  For X = 0 To 29
    For Y = 31 To 0 Step -1
      DrawSingleChar gameImage(&H400 + count) + 64, X, Y, 0
      count = count + 1
    Next Y
  Next X
  
  'Draw sprites
  For X = 0 To 15
    xpos = gameImage(SPRITE_XPOS + X)
    ypos = gameImage(SPRITE_YPOS + X)
    Offset = gameImage(SPRITE_OFFSET + X)
    
    If (ypos < &HF8) Then
      drawsprite Offset, xpos, ypos
    End If
  Next X
  
  Blit vScreen, Arcade.ArcadeScreen, 256&, 256&
  Arcade.ArcadeScreen.Refresh
  
End Function
  
Public Function DrawSingleChar(CharNo As Integer, X As Integer, Y As Integer, palette As Integer)
  Dim cx As Integer
  Dim cy As Integer
  Dim start As Integer
  Dim hdc As Integer
  Dim x1 As Integer
  Dim y1 As Integer
  x1 = X * 8
  y1 = Y * 8
  start = CharNo * 64
    
'  hdc = arcade.ArcScreen(viewpic).hdc
  For cy = y1 To y1 + 7
    For cx = x1 To x1 + 7
       vScreen(cy * 256& + cx) = QBColor(WarpCharSet(start))
       'VirtualScreen(viewpic, cx, cy) = WarpCharSet(start)
 '     SetPixel hdc, cx, cy, QBColor(WarpCharSet(start))
      start = start + 1
    Next cx
  Next cy
  'End With
End Function

Public Function drawsprite(Offset As Integer, X As Integer, Y As Integer)
  Dim cx As Integer, cy As Integer, start As Integer
  Dim SpOffset As Integer
  Dim Flip As Integer
  Dim ypos As Byte, xpos As Byte
  Dim hdc As Integer
  
  SpOffset = (Offset And &H3E)
  Flip = 1
  start = SpOffset * 64
  
  If (Offset And &H1) = &H1 Then start = start + 8192
  If (Offset And &H80) = &H80 Then Flip = 0
    
'  hdc = arcade.ArcScreen(viewpic).hdc
  
  For cy = 7 To 0 Step -1
    For cx = 0 To 7
      ypos = 255 - (Y + cy)
      If (Flip) Then
        If (238 - (X - cx)) < 0 Then
          xpos = (256 + 238) - (X - cx)
        Else
          xpos = 238 - (X - cx)
        End If
        If WarpCharSet(start) = 0 Then
        Else
          If xpos < &HF0 Then
            vScreen(ypos * 256& + xpos) = QBColor(WarpCharSet(start))
            'VirtualScreen(viewpic, xpos, ypos) = WarpCharSet(start)
            
'            SetPixel hdc, xpos, ypos, QBColor(WarpCharSet(start))
          End If
        End If
        
        If WarpCharSet(start + 64) = 0 Then
        Else
          If (xpos + 8) < &HF0 Then
            vScreen(ypos * 256& + xpos + 8) = QBColor(WarpCharSet(start + 64))
            'VirtualScreen(viewpic, xpos + 8, ypos) = WarpCharSet(start + 64)
'            SetPixel hdc, xpos + 8, ypos, QBColor(WarpCharSet(start + 64))
          End If
        End If
      Else
        If 238 - (X - (8 - cx)) < 0 Then
          xpos = 256 + 238 - (X - (8 - cx))
        Else
          xpos = 238 - (X - (8 - cx))
        End If
        If WarpCharSet(start) = 0 Then
        Else
          If (xpos + 8) < &HF0 Then
            vScreen(ypos * 256& + xpos + 8) = QBColor(WarpCharSet(start))
            'VirtualScreen(viewpic, xpos + 8, ypos) = WarpCharSet(start)
'            SetPixel hdc, xpos + 8, ypos, QBColor(WarpCharSet(start))
          End If
        End If
        If WarpCharSet(start + 64) = 0 Then
        Else
          If (xpos < &HF0) Then
            vScreen(ypos * 256& + xpos) = QBColor(WarpCharSet(start + 64))
            'VirtualScreen(viewpic, xpos, ypos) = WarpCharSet(start + 64)
'            SetPixel hdc, xpos, ypos, QBColor(WarpCharSet(start + 64))
          End If
        End If
      End If
      start = start + 1
    Next cx
  Next cy

End Function

Public Function DisplayCharSet()
  Dim X As Integer
  Dim Y As Integer
  For X = 0 To 31
    For Y = 0 To 7
      DrawSingleChar (Y * 32) + X, X, Y, 0
    Next Y
  Next X
End Function
